package xyz.twovb.sgm.levels;

/*
 * Created by 2vb - 4/6/2024
 */

import org.bukkit.*;
import org.bukkit.block.Block;
import xyz.twovb.sgm.SGM;
import xyz.twovb.sgm.games.Minigame;

import java.io.File;

public class LevelManager {

    public enum Result {
        SUCCESS,
        WORLD_EXISTS,
        INVALID_ARGS,
        UNKNOWN
    }

    private final String path = SGM.getInstance().getDataFolder().getPath() + "/levels/";

    public Result createLevel(String name, String game) {
        if (SGM.getInstance().getGameManager().getRegisteredGames().containsKey(game.toLowerCase())) {
            return Result.INVALID_ARGS;
        }
        WorldCreator wc = new WorldCreator(path + name, new NamespacedKey(SGM.getInstance(), "level_" + name));
        if (new File(path + name).exists()) {
            return Result.WORLD_EXISTS;
        }
        wc.type(WorldType.FLAT);
        wc.generatorSettings("{\"layers\": [{\"block\": \"air\", \"height\": 1}], \"biome\":\"plains\"}");
        wc.generateStructures(false);
        World world = wc.createWorld();
        if (world == null) {
            return Result.UNKNOWN;
        }
        Location location = new Location(world, 0, 0, 0);
        Block block = location.subtract(0, 1, 0).getBlock();
        block.setType(Material.STONE);
        world.setSpawnLocation(location);
        world.setSpawnFlags(false, false);
        return Result.SUCCESS;
    }

//    public void deleteLevel(String name) {
//        World world = Bukkit.getWorld(new NamespacedKey(SGM.getInstance(), "level_" + name));
//        assert world != null;
//        Bukkit.unloadWorld(world, false);
//    }

}